#ifndef __WCHAR_H
#define __WCHAR_H

#define NULL		@impdef@
#define WEOF		@impdef@
#define WCHAR_MAX	@impdef@
#define WCHAR_MIN	@impdef@

typedef @impdef@ size_t;
typedef @impdef@ wchar_t;
typedef @impdef@ wint_t;
typedef @impdef@ mbstate_t;

wint_t fgetwc(FILE *stream);
wchar_t *fgetws(wchar_t *s, int n, FILE *stream);
int fputws(const wchar_t *s, FILE *stream);
wint_t getwc(FILE *stream);
wint_t getwchar(void);
wint_t ungetwc(wint_t c, FILE *stream);
double wcstod(const wchar_t *nptr, wchar_t **endptr);
long int wcstol(const wchar_t *nptr, wchar_t **endptr, int base);
unsigned long int wcstoul(const wchar_t *nptr, wchar_t **endptr,
			  int base);
wchar_t *wcscpy(wchar_t *s1, const wchar_t *s2);
wchar_t *wcsncpy(wchar_t *s1, const wchar_t *s2, size_t n);
wchar_t *wcscat(wchar_t *s1, const wchar_t *s2);
wchar_t *wcsncat(wchar_t *s1, const wchar_t *s2, size_t n);
int wcscmp(const wchar_t *s1, const wchar_t *s2);
int wcscoll(const wchar_t *s1, const wchar_t *s2);
int wcsncmp(const wchar_t *s1, const wchar_t *s2, size_t n);
size_t wcsxfrm(wchar_t *s1, const wchar_t *s2, size_t n);
size_t wcscspn(const wchar_t *s1, const wchar_t *s2);e
size_t wcsspn(const wchar_t *s1, const wchar_t *s2);
size_t wcslen(const wchar_t *s);
wchar_t *wcschr(const wchar_t *s, wchar_t c);
wchar_t *wcsrchr(const wchar_t *s1, wchar_t c);
wchar_t *wcspbrk(const wchar_t *s1, const wchar_t *s2);
int fwprintf(FILE *stream, const wchar_t *format, ...);
int fwscanf(FILE *stream, const wchar_t *format, ...);
@newpage@
int wprintf(const wchar_t *format, ...);
int wscanf(const wchar_t *format, ...);
int swprintf(wchar_t *s, size_t n, const wchar_t *format, ...);
int swscanf(const wchar_t *s, const wchar_t *format, ...);
int vfwprintf(FILE *stream, const wchar_t *format, va_list arg);
int vwprintf(const wchar_t *format, va_list arg);
int vswprintf(wchar_t *s, size_t n, const wchar_t *format,
	      va_list arg);
wint_t fputwc(wchar_t c, FILE *stream);
wint_t putwc(wchar_t c, FILE *stream);
wint_t putwchar(wchar_t c);
int fwide(FILE *stream, int mode);
extern wchar_t *wcstok(wchar_t *s1, const wchar_t *s2, wchar_t **ptr);
wchar_t *wcsstr(const wchar_t *s1, const wchar_t *s2);
wchar_t *wmemchr(const wchar_t *s, wchar_t c, size_t n);
int wmemcmp(const wchar_t *s1, const wchar_t *s2, size_t n);
wchar_t *wmemcpy(wchar_t *s1, const wchar_t *s2, size_t n);
wchar_t *wmemmove(wchar_t *s1, const wchar_t *s2, size_t n);
wchar_t *wmemset(wchar_t *s, wchar_t c, size_t n);
size_t wcsftime(wchar_t *s, size_t n, const wchar_t *format,
		const struct tm *timeptr);
wint_t btowc(int c);
int wctob(wint_t c);
int mbsinit(const mbstate_t *ps);
size_t mbrlen(const char *s, size_t n, mbstate_t *pcs);
size_t mbrtowc(wchar_t *ws, const char *s, size_t n, mbstate_t *ps);
size_t wcrtomb(char *s, wchar_t c, mbstate_t *s);
size_t mbsrtowcs(wchar_t *ws, const char **src, size_t n,
		 mbstate_t *ps);
size_t wcsrtombs(char *s, const wchar_t **src, size_t n,
		 mbstate_t *ps);

#endif /* !__WCHAR_H */
