#include <stdarg.h>
#include <stdio.h>

/*
 * Print the arguments plus their type.
 * The first argument `fmt' specifies the type of the other
 * arguments:
 *   c means char
 *   d means int
 *   s means string (char *)
 * For example:
 *    print_types("cds", 'x', 10, "abc");
 * Prints:
 *    char = 'x'
 *    int = 10
 *    string = "abc"
 */
void print_types(const char *fmt, ...)
{
    va_list ap;

    va_start(ap, fmt);
    for (; *fmt != '\0'; ++fmt)
	switch (*fmt) {
	case 'c':
	    printf("char = '%c'\n", va_arg(ap, char));
	    break;
	case 'd':
	    printf("int = %d\n", va_arg(ap, int));
	    break;
	case 's':
	    printf("string = \"%s\"\n", va_arg(ap, char *));
	    break;
	}
    va_end(ap);
}
