#include <stdio.h>
#include <stdlib.h>

/*
 * Get the next token taken from the `sep' separated argument
 * string `s'.
 * Return NULL when there are no more tokens available.
 */
char *next_token(char *buf, const char **s, int sep)
{
    char *dp = buf;

    while (**s == sep)
	++*s;
    if (**s == '\0')
	return NULL;
    while (**s != sep && **s != '\0')
	*dp++ = *(*s)++;
    *dp = '\0';

    return buf;
}

/*
 * Print the tokens in witch is composed the colon `:' separated
 * argument string.
 */
void print_tokens(const char *s)
{
    char buf[32];
    while (next_token(buf, &s, ':') != NULL)
	printf("token = `%s'\n", buf);
}

int main(void)
{
    print_tokens("/bin:/sbin:/usr/bin:/usr/sbin:.");
    return EXIT_SUCCESS;
}
