#ifndef __STDIO_H
#define __STDIO_H

#define _IOFBF	       	/* implementation defined */
#define _IOLBF	       	/* implementation defined */
#define _IONBF	       	/* implementation defined */
#define BUFSIZ	       	/* implementation defined */
#define EOF	       	/* implementation defined */
#define FILENAME_MAX   	/* implementation defined */
#define FOPEN_MAN      	/* implementation defined */
#define L_tmpnam       	/* implementation defined */
#define NULL	       	/* implementation defined */
#define SEEK_CUR       	/* implementation defined */
#define SEEK_END       	/* implementation defined */
#define SEEK_SET       	/* implementation defined */
#define TMP_MAX	       	/* implementation defined */

typedef /* implementation defined */ FILE;
typedef /* implementation defined */ fpos_t;
typedef /* implementation defined */ size_t;

FILE *stderr;
FILE *stdin;
FILE *stdout;

int remove(const char *filename);
int rename(const char *old, const char *new);
FILE *tmpfile(void);
char *tmpnam(char *s);
int fclose(FILE *stream);
int fflush(FILE *stream);
FILE *fopen(const char *filename, const char *mode);
FILE *freopen(const char *filename, const char *mode,
              FILE *stream);
void setbuf(FILE *stream, char *buf);
int setvbuf(FILE *stream, char *buf, int mode, size_t size);
int fprintf(FILE *stream, const char *format, ...);
int fscanf(FILE *stream, const char *format, ...);
int printf(const char *format, ...);
int scanf(const char *format, ...);
int sprintf(char *s, const char *format, ...);
int sscanf(const char *s, const char *format, ...);
int vfprintf(FILE *stream, const char *format, va_list arg);
int vprintf(const char *format, va_list arg);
int vsprintf(char *s, const char *format, va_list arg);
int fgetc(FILE *stream);
char *fgets(char *s, int n, FILE *stream);
int fputc(int c, FILE *stream);
int fputs(const char *s, FILE *stream);
int getc(FILE *stream);
int getchar(void);
char *gets(char *s);
int putc(int c, FILE *stream);
int putchar(int c);
int puts(const char *s);
int ungetc(int c, FILE *stream);
size_t fread(void *ptr, size_t size, size_t n, FILE *stream);
size_t fwrite(const void *ptr, size_t size, size_t n,
              FILE *stream);
int fgetpos(FILE *stream, fpos_t *pos);
int fseek(FILE *stream, long int offset, int whence);
int fsetpos(FILE *stream, const fpos_t *pos);
long int ftell(FILE *stream);
void rewind(FILE *stream);
void clearerr(FILE *stream);
int feof(FILE *stream);
int ferror(FILE *stream);
void perror(const char *s);

#endif /* !__STDIO_H */
