#include <string.h>

char *strtok(char *s, const char *delim)
{
    const char *sp;
    char *s_begin, *s_end;
    static char *s_save = NULL;

    s_begin = (s != NULL) ? s : s_save;
    if (s_begin == NULL)
	return NULL;

    /* Skip the delimiters. */
    for (;;) {
	if (*s_begin == '\0') {
	    s_save = NULL;
	    return NULL;
	}
	for (sp = delim; *sp != '\0'; ++sp)
	    if (*s_begin == *sp) {
		++s_begin;
		break;
	    }
	if (*sp == '\0')
	    break;
    }

    /* Find the token end. */
    for (s_end = s_begin; *s_end != '\0'; ++s_end) {
	for (sp = delim; *sp != '\0'; ++sp)
	    if (*s_end == *sp)
		break;
	if (*sp != '\0')
	    break;
    }
    if (*s_end != '\0')
	*s_end++ = '\0';
    s_save = s_end;

    return s_begin;
}
