#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#define PI	3.14159265358979323846
#define G	9.80665

int main(int argc, char **argv)
{
	double distance, angle, speed, time, maxheight;

	if (argc < 2 || argc > 3) {
		fprintf(stderr, "usage: cannon <distance> [angle]\n"
			"\tdistance is expressed in meters\n"
			"\tangle is expressed in degrees "
			"(optional, default is 45)\n");
		return 1;
	}

	distance = atof(argv[1]);
	if (argc == 2)
		angle = 45;
	else
		angle = atof(argv[2]);
	/* Convert angle into radians. */
	angle = PI/180 * angle;

	/* Calculate initial speed. */
	speed = sqrt((.5 * G * pow(distance, 2)) /
		     (tan(angle) * distance * pow(cos(angle), 2)));
	/* Calculate fly time. */
	time = 2 * speed * sin(angle) / G;
	/* Calculate maximum height. */
	maxheight = pow(speed * sin(angle), 2) / (2 * G);

	printf("distance: %.2f m, angle: %.2f rad\n"
	       "initial speed: %.2f m/s, "
	       "fly time: %.2f s, maximum height: %.2f m\n",
	       distance, angle, speed, time, maxheight);

	return 0;
}
