#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define SIN_PRECISION 10

int fact(int i)
{
	int n;
	if (i < 2)
		return 1;
	else
		for (n = 1; i >= 2; --i)
			n *= i;
	return n;
}

#define PI 3.141592654

double xcos(double x)
{
	double sum = 0;
	int n;

	while (x + PI/2 > (double)2*PI)
		x -= (double)2*PI;

	for (n = 0; n <= SIN_PRECISION; ++n)
		sum += pow(-1, n)*pow(x, 2*n)/fact(2*n);
	return sum;
}

double xsin(double x)
{
	double sum = 0;
	int n;

	for (n = 0; n <= SIN_PRECISION; ++n)
		sum += pow(-1, n)*pow(x, 2*n + 1)/fact(2*n + 1);
	return sum;
}

int main(int argc, char **argv)
{
	double d;
	if (argc != 2)
		return 1;
	d = atof(argv[1]);
	printf("%f: sin(): %.10f, xsin(): %.10f\n", d, sin(d), xsin(d));
	printf("%f: cos(): %.10f, xcos(): %.10f\n", d, cos(d), xcos(d));
	return 0;
}
